Library V_Bang;

Uses vc_engine,
  lstool in 'lstool.pas';

Var
  VolumeStepWidth,
  BalanceStepWidth: Byte;
  
function AddBangCommand(command:string;f:pointer):Boolean; cdecl; external 'lsapi.dll';
function RemoveBangCommand(command:string):Boolean; cdecl; external 'lsapi.dll';
function GetRCInt(lpKeyName:string;nDefault:longint):longint; cdecl; external 'lsapi.dll';



procedure Volume_up(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right : Word;
begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,left,right);
  If Right>Left Then Begin
    balance:=Left DIV (Right DIV 100);
    If (Right+(655 * VolumeStepWidth)>65535)then
      Right:=65535 else Inc(Right,(655*VolumeStepWidth));
    Left:=balance*(Right DIV 100);
  End
  Else Begin
    balance:=Right DIV (Left DIV 100);
    If (Left+(655 * VolumeStepWidth)>65535)then
      Left:=65535 else Inc(Left,(655*VolumeStepWidth));
    Right:=balance*(Left DIV 100);
  End;
  SetVolumeA(ch,Left,Right);
end;

procedure Volume_Down(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right: Word;
begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,left,right);
  If Right>Left Then Begin
    balance:=Left DIV (Right DIV 100);
    If (Right-(655 * VolumeStepWidth)<0)then
      Right:=0 else Dec(Right,(655*VolumeStepWidth));
    Left:=balance*(Right DIV 100);
  End
  Else
  If Not(Left=0) then
  Begin
    balance:=Right DIV (Left DIV 100);
    If (Left-(655 * VolumeStepWidth)<0)then
      Left:=0 else Dec(Left,(655*VolumeStepWidth));
    Right:=balance*(Left DIV 100);
  End;
  SetVolumeA(ch,Left,Right);
end;

procedure Mute(Caller:Integer;Args:pchar); cdecl;
Var
  ch : Byte;
Begin
  ch := StrToInt(GetVarN(args,1));
    SetMute(ch,NOT(GetMute(ch)));
End;

procedure Balance_right(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right : Word;
Begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,Left,Right);
  If (Right>Left)AND(Right>0) Then
  Begin
    balance:=Left DIV (Right DIV 100);
    If (balance-BalanceStepWidth>=0) then
       Dec(balance,BalanceStepWidth) else balance:=0;
    Left:=balance*(Right DIV 100);
  end;
  If (Right<=Left)AND(Left>0) Then
  Begin
    balance:=Right DIV (Left DIV 100);
    If (balance+BalanceStepWidth<=100) then
    Begin
      inc(balance,BalanceStepWidth);
      Right:=balance*(Left DIV 100);
    end else
    Begin
      inc(balance,BalanceStepWidth);
      Right:=Left;
      lEft:=(100-(balance-100))*(Right DIV 100);
    end;
  end;
  SetVolumeA(ch,Left,Right);
end;

procedure Balance_left(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right : Word;
Begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,Left,Right);
  If (Left>Right)AND(Left>0) Then
  Begin
      balance:=Right DIV (Left DIV 100);
      If (balance-BalanceStepWidth>=0) then
        Dec(balance,BalanceStepWidth) else balance:=0;
      Right:=balance*(Left DIV 100);
  end;
  If (Left<=Right)AND(Right>0) Then
  Begin
    balance:=Left DIV (Right DIV 100);
    If (balance+BalanceStepWidth<=100) then
    Begin
      inc(balance,BalanceStepWidth);
      Left:=balance*(Right DIV 100);
    end else
    Begin
      inc(balance,BalanceStepWidth);Left:=Right;
      Right:=(100-(balance-100))*(Left DIV 100);
    end;
  end;
  SetvolumeA(ch,Left,Right);
End;

Procedure Set_Balance(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right : Word;
Begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,left,right);
  balance := StrToInt(GetVarN(args,2));
  If balance<=0 then
  Begin
    If Right>Left then
    Begin
      Left:=Right;
      Right:=(100+balance)*(Left DIV 100);
    end
    else
      Right:=(100+balance)*(Left DIV 100);
  end;
  If balance>0 then
  Begin
    If Left>Right then
    Begin
      Right:=Left;
      Left:=(100-balance)*(Right DIV 100)
    end
    else
      Left:=(100-balance)*(Right DIV 100)
  End;
  SetVolumeA(ch,left,Right);
End;

procedure Set_Volume(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance: Shortint;
  Left, Right : Word;
Begin
  ch := StrToInt(GetVarN(args,1));
  GetVolumeA(ch,left,right);
   If Right>Left Then Begin
     balance := Left DIV (Right DIV 100);
     Right := trunc(655.35*StrToInt(GetVarN(args,3)));
     Left:= trunc(balance*((655.35*StrToInt(GetVarN(args,2)))/100));
   End Else
     If Right<Left then Begin
       balance := Right DIV (Left DIV 100);
       Left := trunc(655.35*StrToInt(GetVarN(args,2)));
       Right := trunc(balance*((655.35*StrToInt(GetVarN(args,3)))/100));
     End
     Else Begin
       Left  := trunc(655.35*StrToInt(GetVarN(args,2)));
       Right := trunc(655.35*StrToInt(GetVarN(args,3)));
     end;
  SetVolumeA(ch,Left,Right);
End;

function initModuleEx(ParentWnd:Integer;dllInst:Longint;szPath:PCHAR):longint; cdecl;
begin
  Init(0);
  VolumeStepWidth := GetRCInt('VolumeStepWidth',10);
  BalanceStepWidth := GetRCInt('BalanceStepWidth',10);
  Begin
    AddBangCommand('!Volume_up',@Volume_up);
    AddBangCommand('!Volume_down',@Volume_down);
    AddBangCommand('!Mute',@Mute);
    AddBangCommand('!Balance_left',@Balance_left);
    AddBangCommand('!Balance_right',@Balance_right);
    AddBangCommand('!Set_Balance',@Set_Balance);
    AddBangCommand('!Set_Volume',@Set_Volume);
   // AddBangCommand('!Toggle_VBang',@Toggle_VBang);
  end;
  result:=0
end;


procedure quitModule(dllInst:Longint); cdecl;
begin
  RemoveBangCommand('!Volume_up');
  RemoveBangCommand('!Volume_down');
  RemoveBangCommand('!Mute');
  RemoveBangCommand('!Balance_right');
  RemoveBangCommand('!Balance_left');
  RemoveBangCommand('!Set_Balance');
  RemoveBangCommand('!Set_Volume');
 // RemoveBangCommand('!Toggle_VBang');
  Destroy;
end;


Function GetVolume(ch:integer):Integer; cdecl;
Var
  Left, Right : Word;
Begin
  GetVolumeA(ch, Left, Right);
  If Left>Right Then Result:=Left
  Else Result:=Right
End;

Procedure SetVolume(ch,vol:integer); cdecl;
Var
  balance: Shortint;
  Left, Right : Word;
Begin
  GetVolumeA(ch,Left,Right);
    IF Right>Left then
    Begin
      balance := Left DIV (Right DIV 100);
      Right := trunc(655.35*vol);
      Left :=balance*(Right DIV 100);
    end;
    IF Left>Right then
    Begin
      balance:=Right DIV (Left DIV 100);
      Left:=trunc(655.35*vol);
      Right:=balance*(Left DIV 100);
    end;
    IF Right=Left then
    Begin
      Right:=trunc(655.35*vol);
      Left:=Right;
    end;
  SetvolumeA(ch,Left,Right);
end;

Function GetBalance(ch:integer):Integer; cdecl;
Var Left, Right : Word;

Begin
  GetVolumeA(ch,Left,Right);
  If Right>Left then
    Result:=(100-Left DIV (Right DIV 100))
  else
    Result:=-(100-Right DIV (Left DIV 100));
end;

Procedure SetBalance(ch,balance:integer); cdecl;
Var
  Left, Right : Word;
Begin
  GetVolumeA(ch,Left,Right);
  If balance<=0 then
  Begin
    If Right>Left then
    Begin
      Left:=Right;
      Right:=(100+balance)*(Left DIV 100);
    end
    else
      Right:=(100+balance)*(Left DIV 100);
  end;
  If balance>0 then
  Begin
    If Left>Right then
    Begin
      Right:=Left;
      Left:=(100-balance)*(Right DIV 100)
    end
    else
      Left:=(100-balance)*(Right DIV 100)
  End;
  SetvolumeA(ch,Left,Right);
End;

exports
  initModuleEx,
  quitModule,
  GetVolume,
  SetVolume,
  GetBalance,
  SetBalance;


end.

