unit vc_engine;

interface

procedure init(Owner : Integer);

Procedure SetVolumeA(ch: integer; Left, Right: Word);
Procedure SetMute(ch: Integer; Mute: Boolean);
Procedure GetVolumeA(ch: integer;Var Left, Right: Word);
function GetMute(ch: Integer): Boolean;

procedure Destroy;

implementation

const
  MIXER_GETLINECONTROLSF_ALL          = $00000000;
  MIXERCONTROL_CONTROLTYPE_VOLUME         = (($50000000 or $00030000) + 1);
  MIXERCONTROL_CONTROLTYPE_MUTE           = (($20000000 or $00000000 or $00010000) + 2);
  MIXERCONTROL_CONTROLTYPE_PEAKMETER      = (($10000000 or $00000000 or $00020000) + 1);

  CALLBACK_WINDOW     = $00010000;
  MIXER_OBJECTF_MIXER     = $00000000;
  MIXER_GETLINEINFOF_DESTINATION      = $00000000;
  MIXER_GETLINEINFOF_SOURCE           = $00000001;
  MIXER_SETCONTROLDETAILSF_VALUE      = $00000000;
  MIXER_GETCONTROLDETAILSF_VALUE      = $00000000;

Type
  TMixerControl = packed record
    cbStruct,dwControlID,
    dwControlType,fdwControl,
    cMultipleItems: Integer;
    szShortName: array[0..15] of AnsiChar;
    szName: array[0..63] of AnsiChar;
    Bounds: record
      case Integer of
        0: (lMinimum, lMaximum: Longint);
        1: (dwMinimum, dwMaximum: Integer);
        2: (dwReserved: array[0..5] of Integer);
    end;
    Metrics: record
      case Integer of
        0: (cSteps: Integer);
        1: (cbCustomData: Integer);
        2: (dwReserved: array[0..5] of Integer);
    end;
  end;

  PMixerControl = ^TMixerControl;

  TMixerLine = record
    cbStruct,dwDestination,
    dwSource,dwLineID,fdwLine,
    dwUser,dwComponentType,
    cChannels,cConnections,
    cControls: Integer;
    szShortName: array[0..15] of AnsiChar;
    szName: array[0..63] of AnsiChar;
    Target: record
      dwType,
      dwDeviceID: Integer;
      wMid,
      wPid: WORD;
      vDriverVersion: Integer;
      szPname: array[0..31] of AnsiChar;
	 end;
  end;

  PMixerLine = ^TMixerLine;

  TMixerLineControls = record
    cbStruct,
    dwLineID: Integer;
    case Integer of
      0: (dwControlID: Integer);
      1: (dwControlType,
          cControls,
          cbmxctrl: Integer;
          pamxctrl: PMixerControl);
  end;

  PMixerLineControls = ^TmixerLineControls;

  TMixerControlDetails = record
    cbStruct,
    dwControlID,
    cChannels: Integer;
    case Integer of
	   0: (hwndOwner: Integer);
	   1: (cMultipleItems,
	       cbDetails: Integer;
	       paDetails: Pointer); 
  end;

  PMixerControlDetails = ^TMixerControlDetails;

  TMixerControlDetailsUnsigned = record
    dwValue: Integer;
  end;

  TMixerControlDetailsBoolean = record
    fValue: Longint;
  end;

  PHMIXER = ^HMIXER;
  HMIXER = Integer;

  TvArray = Array[0..10]of TMixerControl;

Var
  mixHandle :  HMIXER;
  error     :  Integer;
  Lines : ^TvArray;
  Mutes : ^TvArray;
  Amps : ^TvArray;
  V_C,M_C,A_C : Byte;

//External Functions
function mixerGetLineControls(hmxobj: Integer; pmxlc: PMixerLineControls; fdwControls: Integer): Integer; stdcall; external 'winmm.dll' name 'mixerGetLineControlsA';
function mixerOpen(phmx: PHMIXER; uMxId: Integer; dwCallback, dwInstance, fdwOpen: Integer): Integer; stdcall; external 'winmm.dll';
function mixerGetLineInfo(hmxobj: Integer; pmxl: PMixerLine; fdwInfo: Integer): Integer; stdcall; external 'winmm.dll' name 'mixerGetLineInfoA';
function mixerSetControlDetails(hmxobj: Integer; pmxcd: PMixerControlDetails; fdwDetails: Integer): Integer; stdcall; external 'winmm.dll';
function mixerGetControlDetails(hmxobj: Integer; pmxcd: PMixerControlDetails; fdwDetails: Integer): Integer; stdcall; external 'winmm.dll' name 'mixerGetControlDetailsA';
function mixerClose(hmx: HMIXER): Integer; stdcall; external 'winmm.dll';


procedure init(Owner : Integer);
Var
  mixConnLineInfo,
  mixLineInfo : TMixerLine;
  mixLineControl : TMixerLineControls;
  pmixControl,
  pmxctrl: PMixerControl;
  Connection : Integer;

  Procedure GetLineControls(mixLineInfo : TMixerLine);
  Var
    i : integer;
  Begin
    WITH mixLineControl  DO BEGIN
     cbStruct  := SizeOf(TMixerLineControls);
     dwLineID  := mixLineInfo.dwLineID;
     cControls := mixLineInfo.cControls;
     cbmxctrl  := SizeOf(TMixerControl);

     GetMem(pmixControl, SizeOf(TMixerControl) * mixLineInfo.cControls);

     pamxctrl  := pmixControl;
    END;

  error := mixerGetLineControls(mixHandle, @mixLineControl, MIXER_GETLINECONTROLSF_ALL);

  pmxctrl := pmixControl;

    FOR i := 0 TO mixLineControl.cControls -1 DO BEGIN

      If pmxctrl^.dwControlType=MIXERCONTROL_CONTROLTYPE_VOLUME then Begin
        Lines^[v_c] := pmxctrl^;Inc(v_c);end;

      If pmxctrl^.dwControlType=MIXERCONTROL_CONTROLTYPE_MUTE then Begin
        Mutes^[m_c] := pmxctrl^;Inc(m_c);End;

      If pmxctrl^.dwControlType=MIXERCONTROL_CONTROLTYPE_PEAKMETER then Begin
        Amps^[a_c] := pmxctrl^;Inc(a_c);End;

    Inc(pmxctrl);
  end;
  end;

Begin
  new(Lines);V_C := 0;
  new(Mutes);M_C := 0;
  new(Amps);A_C := 0;

  error := mixerOpen(@mixhandle, 0, Owner, 0, CALLBACK_WINDOW OR MIXER_OBJECTF_MIXER);

  mixLineInfo.cbStruct      := SizeOf(TMixerLine);
  mixLineInfo.dwDestination := 0;

  error := mixerGetLineInfo(mixHandle, @mixLineInfo, MIXER_GETLINEINFOF_DESTINATION);

  GetLineControls(mixLineInfo);
  FOR connection := 0 TO mixLineInfo.cConnections-1 DO BEGIN

    WITH mixConnLineInfo DO BEGIN
      cbStruct      := SizeOf(TMixerLine);
      dwDestination := 0;
      dwSource      := connection;
    END;

    error := mixerGetLineInfo(mixHandle, @mixConnLineInfo, MIXER_GETLINEINFOF_SOURCE);

    GetLineControls(mixConnLineInfo);
  End;

End;

Procedure SetVolumeA(ch: integer; Left, Right: Word);
Var
  Values : ARRAY[0..1] OF TMixerControlDetailsUnsigned;
  mixControlDetails : TMixerControlDetails;
begin
   Values[0].dwvalue := Left;
   Values[1].dwvalue := Right;

   With mixControlDetails Do begin
       cbStruct       := SizeOf(TMixerControlDetails);
       dwControlID    := Lines[ch].dwControlID;
       cChannels      := 2;
       cMultipleItems := 0;
       cbDetails      := sizeof(TMixerControlDetailsUnsigned);
       padetails      := @values;
   end;
   error := mixerSetControlDetails(mixHandle , @mixControlDetails,
                                               MIXER_SETCONTROLDETAILSF_VALUE);
end;

Procedure SetMute(ch: Integer; Mute: Boolean);
Var
  Values : ARRAY[0..1] OF TMIXERCONTROLDETAILSBOOLEAN;
  mixControlDetails : TMixerControlDetails;
Begin
   Values[0].fValue := Integer(Mute);

   WITH mixControlDetails DO BEGIN
            cbStruct    := SizeOf(TMixerControlDetails);
            dwControlID := Mutes[ch].dwControlID;
            cChannels   := 1;
            cMultipleItems := 0;
            cbDetails   := sizeof(TMIXERCONTROLDETAILSBOOLEAN);
            padetails   := @Values;
   END;
   error := mixerSetControlDetails(mixHandle , @mixControlDetails,
                      MIXER_SETCONTROLDETAILSF_VALUE)
end;


Procedure GetVolumeA(ch: integer;Var Left, Right: Word);
Var
  Values : ARRAY[0..1] OF TMixerControlDetailsUnsigned;
  mixControlDetails : TMixerControlDetails;
begin
   WITH mixControlDetails DO BEGIN
       cbStruct       := SizeOf(TMixerControlDetails);
       dwControlID    := Lines[ch].dwControlID;
       cChannels      := 2;
       cMultipleItems := 0;
       cbDetails      := sizeof(TMixerControlDetailsUnsigned);
       padetails      := @values;
   END;
   error := mixerGetControlDetails(mixHandle , @mixControlDetails,
                                             MIXER_GETCONTROLDETAILSF_VALUE);
    Left := Values[0].dwvalue;
    Right := Values[1].dwvalue;
end;


function GetMute(ch: Integer): Boolean;
Var
  Values : ARRAY[0..1] OF TMIXERCONTROLDETAILSBOOLEAN;
  mixControlDetails : TMixerControlDetails;
Begin
   WITH mixControlDetails DO BEGIN
            cbStruct    := SizeOf(TMixerControlDetails);
            dwControlID := Mutes[ch].dwControlID;
            cChannels   := 1;
            cMultipleItems := 0;
            cbDetails   := sizeof(TMIXERCONTROLDETAILSBOOLEAN);
            padetails   := @Values;
   END;
   error := mixerGetControlDetails(mixHandle , @mixControlDetails,
                      MIXER_GETCONTROLDETAILSF_VALUE);
   Result := Boolean(Values[0].fValue)
end;

procedure Destroy;
Begin
  If MixHandle<>0 then
    MixerClose(MixHandle);
  Dispose(Lines);
  Dispose(Mutes);
  Dispose(Amps);
end;

end.

